using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using TIS.Imaging;

namespace VCD_Simple
{
    public partial class Form1 : Form
    {
        private VCDButtonProperty SoftwareTrigger;
        private VCDMapStringsProperty ExposureMode;
        private VCDAbsoluteValueProperty TriggerDelay;
        private VCDAbsoluteValueProperty TriggerDebounceTime;
        private VCDAbsoluteValueProperty TriggerMaskTime;
        private VCDAbsoluteValueProperty TriggerNoiseSuppressionTime;
        private VCDRangeProperty TriggerBurstCount;
        private VCDRangeProperty TriggerBurstInterval;
        private VCDMapStringsProperty TriggerOverlap;

        private int counter = 1;
        public Form1()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Form1_Load
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_Load(object sender, EventArgs e)
        {

            if (icImagingControl1.DeviceValid == false)
            {
                icImagingControl1.ShowDeviceSettingsDialog();
            }



            if (icImagingControl1.DeviceValid)
            {

                SoftwareTrigger = (VCDButtonProperty)icImagingControl1.VCDPropertyItems.
                                                    FindInterface(VCDIDs.VCDID_TriggerMode,
                                                    VCDIDs.VCDElement_SoftwareTrigger,
                                                    VCDIDs.VCDInterface_Button);//錾

                ExposureMode = (VCDMapStringsProperty)icImagingControl1.VCDPropertyItems.
                                                FindInterface(VCDIDs.VCDID_TriggerMode,
                                                "{B6E013CA-76C7-4DDD-9AC8-A17E07C5E3F1}",
                                                VCDIDs.VCDInterface_MapStrings);//

                //gK[Delay錾
                TriggerDelay = (VCDAbsoluteValueProperty)icImagingControl1.VCDPropertyItems.
                                                FindInterface(VCDIDs.VCDID_TriggerMode,
                                                VCDIDs.VCDElement_TriggerDelay,
                                                VCDIDs.VCDInterface_AbsoluteValue);

                //DebounceTime錾;
                TriggerDebounceTime = (VCDAbsoluteValueProperty)icImagingControl1.VCDPropertyItems.
                                                FindInterface(VCDIDs.VCDID_TriggerMode,
                                                VCDIDs.VCDElement_TriggerDebounceTime,
                                                VCDIDs.VCDInterface_AbsoluteValue);

                //MaskTime錾
                TriggerMaskTime = (VCDAbsoluteValueProperty)icImagingControl1.VCDPropertyItems.
                                                FindInterface(VCDIDs.VCDID_TriggerMode,
                                                VCDIDs.VCDElement_TriggerMaskTime,
                                                VCDIDs.VCDInterface_AbsoluteValue);
                //NoiseSuppressionTime錾
                TriggerNoiseSuppressionTime = (VCDAbsoluteValueProperty)icImagingControl1.VCDPropertyItems.
                                                FindInterface(VCDIDs.VCDID_TriggerMode,
                                                VCDIDs.VCDElement_TriggerNoiseSuppressionTime,
                                                VCDIDs.VCDInterface_AbsoluteValue);//gK[Delay錾;

                //BurstCount錾;
                TriggerBurstCount = (VCDRangeProperty)icImagingControl1.VCDPropertyItems.
                                                FindInterface(VCDIDs.VCDID_TriggerMode,
                                                "{B4109964-77E4-4AF3-ACA8-45BBAA861B5C}",
                                                VCDIDs.VCDInterface_Range);

                //BurstInterval錾;
                TriggerBurstInterval = (VCDRangeProperty)icImagingControl1.VCDPropertyItems.
                                                FindInterface(VCDIDs.VCDID_TriggerMode,
                                                "{A9715AB3-69AE-454D-8DF5-7E06D87C109C}",
                                                VCDIDs.VCDInterface_Range);


                //gK[Overlap錾
                TriggerOverlap = (VCDMapStringsProperty)icImagingControl1.VCDPropertyItems.
                                                FindInterface(VCDIDs.VCDID_TriggerMode,
                                                "{7685BF04-C9C9-4AE2-BA69-1278B77F97F6}",
                                                VCDIDs.VCDInterface_MapStrings);



                icImagingControl1.LiveDisplayDefault = false;
                icImagingControl1.DeviceTrigger = true; //gK[[hI
                //JɂĂ͓ڂĂȂ@\ɂȂ܂̂
                //KvɉăRgAEgĂB
                //ExposureMode.Value = 1;//0:Timed 1:Trigger Width
                //TriggerDelay.Value = 0;
                //TriggerDebounceTime.Value = 0;
                //TriggerMaskTime.Value = 0;
                //TriggerNoiseSuppressionTime.Value = 0;
                //TriggerBurstCount.Value = 1;
                //TriggerBurstInterval.Value=100;
                //TriggerOverlap.Value = 1; //ReadOnlŷ߃RgAEg
                //

                icImagingControl1.LiveCaptureContinuous = true; // ImageAvailableCxgĂ
                icImagingControl1.LiveCaptureLastImage = false; // Do not save an image on live stop.
                icImagingControl1.LiveDisplay = false; //Cu摜\Ȃ

                
                icImagingControl1.LiveStart();//CuX^[g
                    
   
            }
        }
        private void IcImagingControl1_ImageAvailable(object sender, ICImagingControl.ImageAvailableEventArgs e)
        {

            ImageBuffer CurrentBuffer = null;
            CurrentBuffer = icImagingControl1.ImageBuffers[e.bufferIndex];@//Cu摜\
            icImagingControl1.DisplayImageBuffer(CurrentBuffer);@//Cu摜\

            //obt@̓eJPEGt@CƂăfBXNɕۑ܂B
            string filename = String.Format("test{0}.jpg", counter);
            CurrentBuffer.SaveAsJpeg(filename, 70);
            counter++;
            
        }


        /// <summary>
        /// Button1_Click
        /// \tggK[
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Button1_Click(object sender, EventArgs e)
        {
            SoftwareTrigger.Push(); //\tgEFAgK[   
            
        }

    }
}